<template lang='pug'>
div.x-codemirror
  span.d-none(ref="contentRef")
    slot
  span(v-show='!showHtml' key='editor')
    textarea.form-control(v-model="content" style="min-height: 10rem;")
    //- CodeMirrorEditor(v-model="content" ref="cmEditorRef"
    //-   :options="cmOptions" @input="onInput")
    div.x-ctrls.m-3
      button.mx-1.btn.btn-outline-secondary.shadow(@click='onHtmlPreview(true)') html
      button.mx-1.btn.btn-outline-primary.shadow(@click='onRender()') render
  span(v-if='showHtml' key='preview')
    pre(style="min-height: 10rem;") {{ htmlPreview }}
    //- CodeMirrorEditor.x-html-preview(v-model="htmlPreview"
    //-   :managedModes='[ "htmlmixed" ]' :options="cmPreviewOptions")
    div.x-ctrls.m-3
      button.mx-1.btn.btn-outline-primary.shadow(@click='onHtmlPreview(false)') edit
    //- BaseRibbon(value="preview")
</template>
<script setup>
// import { CodeMirrorEditor } from '../src';

import axios from 'axios';
// import HtmlMod from 'codemirror/mode/htmlmixed/htmlmixed'; // jshint ignore:line

import { onMounted, onUnmounted, ref, toValue } from 'vue';
import { utils } from "@cern/base-vue3";

const emit = defineEmits([ 'change' ]);

/** @type {any} */
const codemirror = null;

/** @type {V.Ref<HTMLElement|null>} */
const contentRef = ref(null);
const cmEditorRef = ref(null);

const showHtml = ref(false);
const content = ref('');
const htmlContent = ref('');
const htmlPreview = ref('');
const cmOptions = {
  tabSize: 2,
  mode: 'pug',
  lineNumbers: true,
  line: true
}

const cmPreviewOptions = {
  tabSize: 2,
  mode: 'htmlmixed',
  lineNumbers: true, readOnly: true,
  line: true
}


onMounted(() => {
  content.value = contentRef.value?.innerText ?? "";
  onRender();
});

onUnmounted(() => {
  codemirror?.toTextArea();
});

async function pugRender(pretty = false) {
  return axios.post(utils.currentUrl() + 'api/pugRender', toValue(content),
    { headers: { 'Content-Type': 'text/plain' }, params: { pretty: (pretty) ? 1 : 0 } })
    .then((res) => res?.data);
}


async function onRender() {
  htmlContent.value = await pugRender();
  emit("change", htmlContent.value);
}

async function onHtmlPreview(show = true) {
  if (show) {
    htmlPreview.value = await pugRender(true);
    showHtml.value = true;
  }
  else {
    htmlPreview.value = '';
    showHtml.value = false;
  }
}

// function onInput(val) {
//   content.value = val;
// }

function refresh() {
//   cmEditorRef?.refresh();
}

</script>
<style lang="scss">
// @import '../node_modules/codemirror/lib/codemirror.css';
.x-codemirror {
  .CodeMirror {
    z-index: 0;
  }

  .x-ctrls {
    bottom: 0;
    right: 0;
    position: absolute;
    z-index: 1;
  }

  .x-html-preview {
    filter: brightness(95%);
  }
}
</style>
